version: 1

services:
  main:
    image: nginx:1.25.1@sha256:593dac25b7733ffb7afe1a72649a43e574778bf025ad60514ef40f6b5d606247
    port: 80
    depends_on: [dashboard, manager]
    mounts:
      data:
        nginx.conf: /etc/nginx/nginx.conf
    restart: on-failure
    stop_grace_period: 30s
  docker:
    image: docker:dind
    restart: always
    privileged: true
    mounts:
      data:
        umbrel: /umbrel
    environment:
      # Disable TLS
      DOCKER_TLS_CERTDIR: ""
  umbrel:
    depends-on: [docker]
    image: harbor.nirvati.org/nirvati/umbrel:latest
    restart: always
    mounts:
      data:
        umbrel: /umbrel
        share: /nirvati-share
        compat-karen: /karen
    # Connect to DIND
    environment:
      DOCKER_HOST: "tcp://$APP_UMBREL_DOCKER_IP:2375"
      UMBREL_AUTH_SECRET: {{ derive_entropy(identifier="auth-secret") }}
  dashboard:
    image: getumbrel/dashboard:0.5.4@sha256:0662567cc1b0ba2179f65bfae0472d085a7e79f53f502e8d1789a1ecba58744b
    restart: on-failure
    stop_grace_period: 1m30s
  manager:
    image: harbor.nirvati.org/nirvati/umbrel-manager:latest
    restart: on-failure
    stop_grace_period: 5m30s
    user: "1000:1000"
    mounts:
      data:
        umbrel/info.json: /info.json
        umbrel/db: /db
        umbrel/jwt: /jwt
        umbrel/events/signals: /signals
        umbrel/app-data: /app-data
        umbrel/repos: /repos
        umbrel/statuses: /statuses
        manager-logs: /app/logs
      {% if installed_apps is containing("lnd") %}
      lnd: /nirvati-lnd
      {% endif %}
      bitcoin: /nirvati-bitcoin
      tor: /var/lib/tor/
    environment:
      PORT: "3006"
      USER_PASSWORD_FILE: "/db/user.json"
      JWT_PUBLIC_KEY_FILE: "/jwt/jwt.pem"
      JWT_PRIVATE_KEY_FILE: "/jwt/jwt.key"
      JWT_EXPIRATION: "604800"
      UMBREL_SEED_FILE: "/db/umbrel-seed/seed"
      UMBREL_DASHBOARD_HIDDEN_SERVICE_FILE: "/var/lib/tor/web/hostname"
      UMBREL_AUTH_SECRET: {{ derive_entropy(identifier="auth-secret") }}
      BITCOIN_P2P_HIDDEN_SERVICE_FILE: "/var/lib/tor/bitcoin-p2p/hostname"
      BITCOIN_P2P_PORT: 8332
      BITCOIN_RPC_HIDDEN_SERVICE_FILE: "/var/lib/tor/bitcoin-rpc/hostname"
      BITCOIN_RPC_PORT: 8333
      BITCOIN_RPC_USER: {{app_metadata.bitcoin.username}}
      BITCOIN_RPC_PASSWORD: {{app_metadata.bitcoin.password}}
      LND_REST_HIDDEN_SERVICE_FILE: "/var/lib/tor/lnd-rest/hostname"
      LND_GRPC_HIDDEN_SERVICE_FILE: "/var/lib/tor/lnd-grpc/hostname"
      LND_CERT_FILE: "/lnd/tls.cert"
      LND_ADMIN_MACAROON_FILE: "/lnd/data/chain/bitcoin/{{app_metadata.bitcoin.network}}/admin.macaroon"
      SHUTDOWN_SIGNAL_FILE: "/signals/shutdown"
      REBOOT_SIGNAL_FILE: "/signals/reboot"
      GITHUB_REPO: "getumbrel/umbrel"
      UMBREL_VERSION_FILE: "/info.json"
      UPDATE_STATUS_FILE: "/statuses/update-status.json"
      UPDATE_SIGNAL_FILE: "/signals/update"
      UPDATE_LOCK_FILE: "/statuses/update-in-progress"
      BACKUP_STATUS_FILE: "/statuses/backup-status.json"
      DEBUG_STATUS_FILE: "/statuses/debug-status.json"
      REPO_UPDATE_STATUS_FILE: "/statuses/repo-update-status.json"
      TOR_HIDDEN_SERVICE_DIR: "/var/lib/tor"
      IS_UMBREL_OS: "false"
      UMBREL_APP_REPO_URL: "https://github.com/getumbrel/umbrel-apps.git"
  auth:
    image: getumbrel/auth-server:v0.5.1@sha256:afcd9065eab02f98ee6bf705045170a4b385fb5f81e3b168bb92ffb8ac7a1760
    user: "1000:1000"
    restart: on-failure
    environment:
      PORT: 2000
      UMBREL_AUTH_SECRET: {{ derive_entropy(identifier="auth-secret") }}
      MANAGER_IP: $APP_UMBREL_MANAGER_IP
      MANAGER_PORT: 3006
      DASHBOARD_IP: $APP_UMBREL_DASHBOARD_IP
      DASHBOARD_PORT: 3004
    mounts:
      data:
        umbrel/app-data: /app-data
      tor: /var/lib/tor
    required_ports:
      tcp:
        2000: 2000
  safekaren:
    image: harbor.nirvati.org/nirvati/safe-app-updater:latest
    user: 1000:1000
    restart: on-failure
    mounts:
      data:
        compat-karen: /compat-karen
        share: /nirvati-share
      nirvati-root: /nirvati
